## calamares 3.2.11

=== CMakeLists.txt ===
# === This file is part of Calamares - <https://github.com/calamares> ===
#
#   Calamares is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   Calamares is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with Calamares. If not, see <http://www.gnu.org/licenses/>.
#
#   SPDX-License-Identifier: GPL-3.0+
#   License-Filename: LICENSE
#
###
#
# Generally, this CMakeLists.txt will find all the dependencies for Calamares
# and complain appropriately. See below (later in this file) for CMake-level
# options. There are some "secret" options as well:
#
#   SKIP_MODULES    : a space or semicolon-separated list of directory names
#                     under src/modules that should not be built.
#   USE_<foo>       : fills in SKIP_MODULES for modules called <foo>-<something>
#   BUILD_<foo>     : choose additional things to build
#   DEBUG_<foo>     : special developer flags for debugging
#
# Example usage:
#
#   cmake . -DSKIP_MODULES="partition luksbootkeycfg"
#
# One special target is "show-version", which can be built
# to obtain the version number from here.

cmake_minimum_required( VERSION 3.2 FATAL_ERROR )
project( CALAMARES
    VERSION 3.2.11
    LANGUAGES C CXX )

set( CALAMARES_VERSION_RC 0 )  # Set to 0 during release cycle, 1 during development

### OPTIONS
#
option( INSTALL_CONFIG "Install configuration files" OFF )
option( INSTALL_POLKIT "Install Polkit configuration" ON )
option( BUILD_TESTING "Build the testing tree." ON )
option( WITH_PYTHON "Enable Python modules API (requires Boost.Python)." ON )
option( WITH_PYTHONQT "Enable next generation Python modules API (experimental, requires PythonQt)." OFF )
option( WITH_KF5Crash "Enable crash reporting with KCrash." ON )


### USE_*
#
# By convention, when there are multiple modules that implement similar
# functionality, and it only makes sense to have **at most one** of them
# enabled at any time, those modules are named <foo>-<implementation>.
# For example, services-systemd and services-openrc.
#
# Setting up SKIP_MODULES to ignore "the ones you don't want" can be
# annoying and error-prone (e.g. if a new module shows up). The USE_*
# modules provide a way to do automatic selection. To pick exactly
# one of the implementations from group <foo>, set USE_<foo> to the
# name of the implementation. If USE_<foo> is unset, or empty, then
# all the implementations are enabled (this just means they are
# **available** to `settings.conf`, not that they are used).
#
# Currently, only USE_services is in use (to pick only one of the two
# modules, systemd or openrc).
set( USE_services "" CACHE STRING "Select the services module to use" )

### Calamares application info
#
set( CALAMARES_ORGANIZATION_NAME "Calamares" )
set( CALAMARES_ORGANIZATION_DOMAIN "github.com/calamares" )
set( CALAMARES_APPLICATION_NAME  "Calamares" )
set( CALAMARES_DESCRIPTION_SUMMARY
    "The distribution-independent installer framework" )

### Transifex (languages) info
#
# complete = 100% translated,
# good = nearly complete (use own judgement, right now >= 75%)
# ok = incomplete (more than 25% untranslated, at least 5% translated),
# incomplete = <5% translated, placeholder in tx; these are not included.
#
# Language en (source language) is added later. It isn't listed in
# Transifex either. Get the list of languages and their status
# from https://transifex.com/calamares/calamares/ , or (preferably)
# use ci/txstats.py to automatically check.
#
# When adding a new language, take care that it is properly loaded
# by the translation framework. Languages with alternate scripts
# (sr@latin in particular) may need special handling in CalamaresUtils.cpp.
#
# TODO: drop the es_ES translation from Transifex
# TODO: move eo (Esperanto) to _ok once Qt can actually create a
#       locale for it.
#
# NOTE: when updating the list from Transifex, copy these four lines
#       and prefix each variable name with "p", so that the automatic
#       checks for new languages and misspelled ones are done (that is,
#       copy these four lines to four backup lines, add "p", and then update
#       the original four lines with the current translations).
set( _tx_complete ca cs_CZ da de fr he hr hu ko lt pt_BR sq tr_TR
    zh_TW )
set( _tx_good ast en_GB es es_MX et fi_FI gl id it_IT ja nl pl
    pt_PT ro ru sk zh_CN )
set( _tx_ok ar bg el es_PR eu hi is mr nb sl sr sr@latin sv th
    uk )
set( _tx_incomplete be ca@valencia eo fa fr_CH gu kk kn lo mk ne_NP ur uz )

### Required versions
#
# See DEPENDENCIES section below.
set( QT_VERSION 5.9.0 )
set( YAMLCPP_VERSION 0.5.1 )
set( ECM_VERSION 5.18 )
set( PYTHONLIBS_VERSION 3.3 )
set( BOOSTPYTHON_VERSION 1.55.0 )


### CMAKE SETUP
#
set( CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/CMakeModules" )

# CMake 3.9, 3.10 compatibility
if( POLICY CMP0071 )
    cmake_policy( SET CMP0071 NEW )
endif()
if(NOT CMAKE_VERSION VERSION_LESS "3.10.0")
    list(APPEND CMAKE_AUTOMOC_MACRO_NAMES
        "K_PLUGIN_FACTORY_WITH_JSON"
        "K_EXPORT_PLASMA_DATAENGINE_WITH_JSON"
        "K_EXPORT_PLASMA_RUNNER"
    )
endif()


### C++ SETUP
#
set( CMAKE_CXX_STANDARD 14 )
set( CMAKE_CXX_STANDARD_REQUIRED ON )
set( CMAKE_C_STANDARD 99 )
set( CMAKE_C_STANDARD_REQUIRED ON )

# Debugging flags
#
# Possible debugging flags are:
#  - DEBUG_TIMEZONES draws latitude and longitude lines on the timezone
#    widget and enables chatty debug logging, for dealing with the timezone
#    location database.
#  - DEBUG_FILESYSTEMS does extra logging and checking when looking at
#    partition configuration. Lists known KPMCore FS types.
#
# The flags listed here are enabled in Debug builds. By default, none
# are **actually** listed, because they're for such specific scenarios.
set( _enable_debug_flags
    # DEBUG_TIMEZONES
    # DEBUG_FILESYSTEMS
)
# Add those flags to the CXX flags in a suitable format.
foreach( _edf ${_enable_debug_flags} )
    string( APPEND CMAKE_CXX_FLAGS_DEBUG " -D${_edf}" )
endforeach()

set( CMAKE_C_FLAGS                  "${CMAKE_C_FLAGS} -Wall" )
if( CMAKE_CXX_COMPILER_ID MATCHES "Clang" )
    message( STATUS "Found Clang ${CMAKE_CXX_COMPILER_VERSION}, setting up Clang-specific compiler flags." )
    set( CMAKE_C_FLAGS                  "${CMAKE_C_FLAGS} -Wall" )
    set( CMAKE_C_FLAGS_DEBUG            "-g" )
    set( CMAKE_C_FLAGS_MINSIZEREL       "-Os -DNDEBUG" )
    set( CMAKE_C_FLAGS_RELEASE          "-O4 -DNDEBUG" )
    set( CMAKE_C_FLAGS_RELWITHDEBINFO   "-O2 -g" )

    # Clang warnings: doing *everything* is counter-productive, since it warns
    # about things which we can't fix (e.g. C++98 incompatibilities, but
    # Calamares is C++14).
    foreach( CLANG_WARNINGS
        -Weverything
        -Wno-c++98-compat
        -Wno-c++98-compat-pedantic
        -Wno-padded
        -Wno-undefined-reinterpret-cast
        -Wno-global-constructors
        -Wno-exit-time-destructors
        -Wno-missing-prototypes
        -Wno-documentation-unknown-command
        -Wno-unknown-warning-option
    )
        string( APPEND CMAKE_CXX_FLAGS " ${CLANG_WARNINGS}" )
    endforeach()
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNOTREACHED='//'" )

    # Third-party code where we don't care so much about compiler warnings
    # (because it's uncomfortable to patch) get different flags; use
    #       mark_thirdparty_code( <file> [<file>...] )
    # to switch off warnings for those sources.
    set( SUPPRESS_3RDPARTY_WARNINGS "-Wno-everything" )
    set( SUPPRESS_BOOST_WARNINGS " -Wno-zero-as-null-pointer-constant -Wno-disabled-macro-expansion" )

    set( CMAKE_CXX_FLAGS_DEBUG          "-g ${CMAKE_CXX_FLAGS_DEBUG}" )
    set( CMAKE_CXX_FLAGS_MINSIZEREL     "-Os -DNDEBUG" )
    set( CMAKE_CXX_FLAGS_RELEASE        "-O3 -DNDEBUG" )
    set( CMAKE_CXX_FLAGS_RELWITHDEBINFO "-O2 -g" )

    set( CMAKE_TOOLCHAIN_PREFIX "llvm-" )

    set( CMAKE_SHARED_LINKER_FLAGS "-Wl,--no-undefined" )

    set( CALAMARES_AUTOMOC_OPTIONS "-butils/moc-warnings.h" )
    set( CALAMARES_AUTOUIC_OPTIONS --include utils/moc-warnings.h )
else()
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--no-undefined" )
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--fatal-warnings -Wnon-virtual-dtor -Woverloaded-virtual -Werror=return-type" )

    set( SUPPRESS_3RDPARTY_WARNINGS "" )
    set( SUPPRESS_BOOST_WARNINGS "" )

    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNOTREACHED='__builtin_unreachable();'" )
endif()

# Use mark_thirdparty_code() to reduce warnings from the compiler
# on code that we're not going to fix. Call this with a list of files.
macro(mark_thirdparty_code)
    set_source_files_properties( ${ARGV}
        PROPERTIES
            COMPILE_FLAGS "${SUPPRESS_3RDPARTY_WARNINGS}"
            COMPILE_DEFINITIONS "THIRDPARTY"
    )
endmacro()

if( CMAKE_COMPILER_IS_GNUCXX )
    if( CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 4.9 OR
        CMAKE_CXX_COMPILER_VERSION VERSION_EQUAL 4.9 )
        message( STATUS "Found GNU g++ ${CMAKE_CXX_COMPILER_VERSION}, enabling colorized error messages." )
        set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fdiagnostics-color=auto" )
    endif()
endif()

include( FeatureSummary )
include( CMakeColors )


### DEPENDENCIES
#
find_package( Qt5 ${QT_VERSION} CONFIG REQUIRED Concurrent Core Gui Widgets LinguistTools Svg Quick QuickWidgets )
find_package( YAMLCPP ${YAMLCPP_VERSION} REQUIRED )
if( INSTALL_POLKIT )
    find_package( PolkitQt5-1 REQUIRED )
else()
    # Find it anyway, for dependencies-reporting
    find_package( PolkitQt5-1 )
endif()
set_package_properties(
    PolkitQt5-1 PROPERTIES
    DESCRIPTION "Qt5 support for Polkit"
    URL "https://cgit.kde.org/polkit-qt-1.git"
    PURPOSE "PolkitQt5-1 helps with installing Polkit configuration"
)

# Find ECM once, and add it to the module search path; Calamares
# modules that need ECM can do
#   find_package(ECM ${ECM_VERSION} REQUIRED NO_MODULE),
# no need to mess with the module path after.
find_package(ECM ${ECM_VERSION} NO_MODULE)
if( ECM_FOUND )
    set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${CMAKE_MODULE_PATH})
    if ( BUILD_TESTING )
        # ECM implies that we can build the tests, too
        find_package( Qt5 COMPONENTS Test REQUIRED )
        include( ECMAddTests )
    endif()
    include(KDEInstallDirs)
endif()

find_package( KF5 COMPONENTS CoreAddons Crash )
if( NOT KF5Crash_FOUND )
    set( WITH_KF5Crash OFF )
endif()

if( BUILD_TESTING )
    enable_testing()
endif ()

find_package( PythonLibs ${PYTHONLIBS_VERSION} )
set_package_properties(
    PythonLibs PROPERTIES
    DESCRIPTION "C interface libraries for the Python 3 interpreter."
    URL "http://python.org"
    PURPOSE "Python 3 is used for Python job modules."
)

if ( PYTHONLIBS_FOUND )
    include( BoostPython3 )
    find_boost_python3( ${BOOSTPYTHON_VERSION} ${PYTHONLIBS_VERSION_STRING} CALAMARES_BOOST_PYTHON3_FOUND )
    set_package_properties(
        Boost PROPERTIES
        PURPOSE "Boost.Python is used for Python job modules."
    )

    find_package( PythonQt )
    set_package_properties( PythonQt PROPERTIES
        DESCRIPTION "A Python embedding solution for Qt applications."
        URL "http://pythonqt.sourceforge.net"
        PURPOSE "PythonQt is used for Python view modules."
    )
endif()

if( NOT PYTHONLIBS_FOUND OR NOT CALAMARES_BOOST_PYTHON3_FOUND )
    message(STATUS "Disabling Boost::Python modules")
    set( WITH_PYTHON OFF )
endif()
if( NOT PYTHONLIBS_FOUND OR NOT PYTHONQT_FOUND )
    message(STATUS "Disabling PythonQt modules")
    set( WITH_PYTHONQT OFF )
endif()

### Transifex Translation status
#

=== src/CMakeLists.txt ===
include( CalamaresAddPlugin )
include( CalamaresAddModuleSubdirectory )
include( CalamaresAddLibrary )
include( CalamaresAddBrandingSubdirectory )

# library
add_subdirectory( libcalamares )

add_subdirectory( libcalamaresui )

# all things qml
add_subdirectory( qml )

# application
add_subdirectory( calamares )

# plugins
add_subdirectory( modules )

# branding components
add_subdirectory( branding )

=== src/calamares/CMakeLists.txt ===
add_definitions( -DUIDLLEXPORT_PRO )

set( calamaresSources
    main.cpp
    CalamaresApplication.cpp
    CalamaresWindow.cpp

    progresstree/ProgressTreeDelegate.cpp
    progresstree/ProgressTreeItem.cpp
    progresstree/ProgressTreeModel.cpp
    progresstree/ProgressTreeView.cpp
    progresstree/ViewStepItem.cpp
)

include_directories(
    .
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}/../libcalamares

    ../libcalamares
    ../libcalamaresui
)

# Translations
include( CalamaresAddTranslations )
add_calamares_translations( ${CALAMARES_TRANSLATION_LANGUAGES} )

set( final_src ${calamaresSources} ${calamaresRc} ${trans_outfile} )

add_executable( calamares_bin ${final_src} )
set_target_properties(calamares_bin
    PROPERTIES
        ENABLE_EXPORTS TRUE
        RUNTIME_OUTPUT_NAME calamares
)
calamares_automoc( calamares_bin )

target_link_libraries( calamares_bin
    PRIVATE
        ${CALAMARES_LIBRARIES}
        calamaresui
        Qt5::Core
        Qt5::Widgets
)
if( WITH_KF5Crash )
    target_link_libraries( calamares_bin
        PRIVATE
            KF5::CoreAddons
            KF5::Crash
    )
    target_compile_definitions( calamares_bin PRIVATE WITH_KF5Crash )
endif()

install( TARGETS calamares_bin
    BUNDLE DESTINATION .
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install( FILES ${CMAKE_SOURCE_DIR}/data/images/squid.svg
    RENAME calamares.svg
    DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps
)

if( BUILD_TESTING )
    add_executable( loadmodule testmain.cpp )
    target_link_libraries( loadmodule ${CALAMARES_LIBRARIES} Qt5::Core Qt5::Widgets calamaresui )
    # Don't install, it's just for enable_testing
endif()

=== src/libcalamares/CMakeLists.txt ===
# libcalamares is the non-GUI part of Calamares, which includes handling
# translations, configurations, logging, utilities, global storage, and (non-GUI) jobs.

add_definitions(
    ${QT_DEFINITIONS}
    -DQT_SHARED
    -DQT_SHAREDPOINTER_TRACK_POINTERS
    -DDLLEXPORT_PRO
)

configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/CalamaresConfig.h.in
                ${CMAKE_CURRENT_BINARY_DIR}/CalamaresConfig.h )
configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/../calamares/CalamaresVersion.h.in
                ${CMAKE_CURRENT_BINARY_DIR}/CalamaresVersion.h )

set( OPTIONAL_PRIVATE_LIBRARIES "" )
set( OPTIONAL_PUBLIC_LIBRARIES "" )

set( libSources
    CppJob.cpp
    GlobalStorage.cpp
    Job.cpp
    JobExample.cpp
    JobQueue.cpp
    ProcessJob.cpp
    Settings.cpp

    # GeoIP services
    geoip/Interface.cpp
    geoip/GeoIPJSON.cpp
    geoip/Handler.cpp

    # Locale-data service
    locale/Label.cpp
    locale/LabelModel.cpp
    locale/Lookup.cpp

    # Partition service
    partition/PartitionSize.cpp

    # Utility service
    utils/CalamaresUtilsSystem.cpp
    utils/CommandList.cpp
    utils/Dirs.cpp
    utils/Logger.cpp
    utils/PluginFactory.cpp
    utils/Retranslator.cpp
    utils/String.cpp
    utils/UMask.cpp
    utils/Variant.cpp
    utils/Yaml.cpp
)
set( kdsagSources
    kdsingleapplicationguard/kdsingleapplicationguard.cpp
    kdsingleapplicationguard/kdsharedmemorylocker.cpp
    kdsingleapplicationguard/kdtoolsglobal.cpp
    kdsingleapplicationguard/kdlockedsharedmemorypointer.cpp
)
mark_thirdparty_code( ${kdsagSources} )

include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${YAMLCPP_INCLUDE_DIR}
)

### OPTIONAL Python support
#
#
if( WITH_PYTHON )
    list( APPEND libSources
        PythonHelper.cpp
        PythonJob.cpp
        PythonJobApi.cpp
    )
    set_source_files_properties( PythonJob.cpp
        PROPERTIES COMPILE_FLAGS "${SUPPRESS_BOOST_WARNINGS}"
    )

    include_directories(${PYTHON_INCLUDE_DIRS})
    link_directories(${PYTHON_LIBRARIES})

    include_directories(${Boost_INCLUDE_DIRS})
    link_directories(${Boost_LIBRARY_DIRS})

    list( APPEND OPTIONAL_PRIVATE_LIBRARIES
        ${PYTHON_LIBRARIES}
        ${Boost_LIBRARIES}
    )
endif()

### OPTIONAL GeoIP XML support
#
#
find_package(Qt5 COMPONENTS Xml)
if( Qt5Xml_FOUND )
    list( APPEND libSources geoip/GeoIPXML.cpp )
    list( APPEND OPTIONAL_PUBLIC_LIBRARIES Qt5::Network Qt5::Xml )
endif()

### LIBRARY
#
#
add_library( calamares SHARED ${libSources} ${kdsagSources} )
set_target_properties( calamares
    PROPERTIES
        VERSION ${CALAMARES_VERSION_SHORT}
        SOVERSION ${CALAMARES_VERSION_SHORT}
)
calamares_automoc( calamares )

target_link_libraries( calamares
    LINK_PRIVATE
        ${OPTIONAL_PRIVATE_LIBRARIES}
    LINK_PUBLIC
        ${YAMLCPP_LIBRARY}
        Qt5::Core
        ${OPTIONAL_PUBLIC_LIBRARIES}
)

install( TARGETS calamares
    EXPORT CalamaresLibraryDepends
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

# Make symlink lib/calamares/libcalamares.so to lib/libcalamares.so.VERSION so
# lib/calamares can be used as module path for the Python interpreter.
install( CODE "
    file( MAKE_DIRECTORY \"\$ENV{DESTDIR}/${CMAKE_INSTALL_FULL_LIBDIR}/calamares\" )
    execute_process( COMMAND \"${CMAKE_COMMAND}\" -E create_symlink ../libcalamares.so.${CALAMARES_VERSION_SHORT} libcalamares.so WORKING_DIRECTORY \"\$ENV{DESTDIR}/${CMAKE_INSTALL_FULL_LIBDIR}/calamares\" )
")

# Install header files
file( GLOB rootHeaders "*.h" )
file( GLOB kdsingleapplicationguardHeaders "kdsingleapplicationguard/*.h" )
file( GLOB utilsHeaders "utils/*.h" )

install( FILES ${CMAKE_CURRENT_BINARY_DIR}/CalamaresConfig.h DESTINATION include/libcalamares )
install( FILES ${rootHeaders}                       DESTINATION include/libcalamares )
install( FILES ${kdsingleapplicationguardHeaders}   DESTINATION include/libcalamares/kdsingleapplicationguard )
install( FILES ${utilsHeaders}                      DESTINATION include/libcalamares/utils )

### TESTING
#
#
if ( ECM_FOUND AND BUILD_TESTING )
    ecm_add_test(
            utils/Tests.cpp
        TEST_NAME
            libcalamarestest
        LINK_LIBRARIES
            calamares
            Qt5::Core
            Qt5::Test
    )
    calamares_automoc( libcalamarestest )

    ecm_add_test(
            geoip/GeoIPTests.cpp
            ${geoip_src}
        TEST_NAME
            geoiptest
        LINK_LIBRARIES
            calamares
            Qt5::Test
            ${YAMLCPP_LIBRARY}
    )
    calamares_automoc( geoiptest )

    ecm_add_test(
            partition/Tests.cpp
        TEST_NAME
            libcalamarespartitiontest
        LINK_LIBRARIES
            calamares
            Qt5::Test
    )
    calamares_automoc( libcalamarespartitiontest )

    ecm_add_test(
            locale/Tests.cpp
        TEST_NAME
            libcalamareslocaletest
        LINK_LIBRARIES
            calamares
            Qt5::Test
    )
    calamares_automoc( libcalamareslocaletest )
endif()

if( BUILD_TESTING )
    add_executable( test_geoip geoip/test_geoip.cpp ${geoip_src} )
    target_link_libraries( test_geoip calamares Qt5::Network ${YAMLCPP_LIBRARY} )
    calamares_automoc( test_geoip )
endif()

=== src/libcalamaresui/CMakeLists.txt ===
# libcalamaresui is the GUI part of Calamares, which includes handling
# view modules, view steps, widgets, and branding.

# The UI libs use the non-UI library
include_directories( ${CMAKE_SOURCE_DIR}/src/libcalamares ${CMAKE_BINARY_DIR}/src/libcalamares )

set( calamaresui_SOURCES
    modulesystem/CppJobModule.cpp
    modulesystem/Module.cpp
    modulesystem/ModuleManager.cpp
    modulesystem/ProcessJobModule.cpp
    modulesystem/Requirement.cpp
    modulesystem/RequirementsChecker.cpp
    modulesystem/ViewModule.cpp

    utils/CalamaresUtilsGui.cpp
    utils/DebugWindow.cpp
    utils/ImageRegistry.cpp

    utils/qjsonmodel.cpp
    utils/qjsonitem.cpp

    viewpages/BlankViewStep.cpp
    viewpages/ViewStep.cpp

    widgets/ClickableLabel.cpp
    widgets/FixedAspectRatioLabel.cpp
    widgets/waitingspinnerwidget.cpp
    widgets/WaitingWidget.cpp

    ExecutionViewStep.cpp
    Branding.cpp
    ViewManager.cpp
)

# Don't warn about third-party sources
mark_thirdparty_code(
    utils/ImageRegistry.cpp
    utils/qjsonitem.cpp
    utils/qjsonmodel.cpp
    widgets/waitingspinnerwidget.cpp
)

set( calamaresui_UI
    utils/DebugWindow.ui
)

if( WITH_PYTHON )
    list( APPEND calamaresui_SOURCES
        modulesystem/PythonJobModule.cpp
    )
endif()

if( WITH_PYTHONQT )
    include_directories(${PYTHON_INCLUDE_DIRS})
    # *_DIRS because we also use extensions
    include_directories(${PYTHONQT_INCLUDE_DIRS})

    list( APPEND calamaresui_SOURCES
        modulesystem/PythonQtViewModule.cpp
        utils/PythonQtUtils.cpp
        viewpages/PythonQtJob.cpp
        viewpages/PythonQtViewStep.cpp
        viewpages/PythonQtGlobalStorageWrapper.cpp
        viewpages/PythonQtUtilsWrapper.cpp
    )
    set( OPTIONAL_PYTHON_LIBRARIES
        ${PYTHON_LIBRARIES}
        ${PYTHONQT_LIBRARIES}
    )
endif()

calamares_add_library( calamaresui
    SOURCES ${calamaresui_SOURCES}
    UI ${calamaresui_UI}
    EXPORT_MACRO UIDLLEXPORT_PRO
    LINK_PRIVATE_LIBRARIES
        ${OPTIONAL_PYTHON_LIBRARIES}
    LINK_LIBRARIES
        Qt5::Svg
        Qt5::QuickWidgets
    RESOURCES libcalamaresui.qrc
    EXPORT CalamaresLibraryDepends
    VERSION ${CALAMARES_VERSION_SHORT}
)

find_package( KF5CoreAddons 5.58 QUIET )  # If it's really new
if ( KF5CoreAddons_FOUND )
    target_compile_definitions( calamaresui PRIVATE WITH_KOSRelease )
    target_link_libraries( calamaresui PRIVATE KF5::CoreAddons )
endif()

=== src/modules/contextualprocess/CMakeLists.txt ===
calamares_add_plugin( contextualprocess
    TYPE job
    EXPORT_MACRO PLUGINDLLEXPORT_PRO
    SOURCES
        ContextualProcessJob.cpp
    LINK_PRIVATE_LIBRARIES
        calamares
    SHARED_LIB
)

if( ECM_FOUND AND BUILD_TESTING )
    ecm_add_test(
            Tests.cpp
            ContextualProcessJob.cpp  # Builds it a second time
        TEST_NAME
            contextualprocesstest
        LINK_LIBRARIES
            ${CALAMARES_LIBRARIES}
            calamaresui
            ${YAMLCPP_LIBRARY}
            Qt5::Core
            Qt5::Test
    )
    calamares_automoc( contextualprocesstest )
endif()

=== src/modules/fsresizer/CMakeLists.txt ===
find_package( KPMcore 3.3 )

set( _partition_defs "" )

if ( KPMcore_FOUND )
    find_package( Qt5 REQUIRED DBus )  # Needed for KPMCore
    find_package( KF5 REQUIRED I18n WidgetsAddons )  # Needed for KPMCore

    include_directories( ${KPMCORE_INCLUDE_DIR} ${CMAKE_SOURCE_DIR}/src/modules/partition )

    if ( KPMcore_VERSION VERSION_GREATER "3.3.0")
        list( APPEND _partition_defs WITH_KPMCORE331API) # kpmcore > 3.3.0 with deprecations
    endif()
    if ( KPMcore_VERSION VERSION_GREATER "3.90")
        list( APPEND _partition_defs WITH_KPMCORE4API) # kpmcore 4 with new API
    endif()

    # The PartitionIterator is a small class, and it's easiest -- but also a
    # gross hack -- to just compile it again from the partition module tree.
    calamares_add_plugin( fsresizer
        TYPE job
        EXPORT_MACRO PLUGINDLLEXPORT_PRO
        SOURCES
            ResizeFSJob.cpp
            ${PROJECT_SOURCE_DIR}/src/modules/partition/core/PartitionIterator.cpp
        LINK_PRIVATE_LIBRARIES
            kpmcore
            calamares
        COMPILE_DEFINITIONS ${_partition_defs}
        SHARED_LIB
    )

    if( ECM_FOUND AND BUILD_TESTING )
        ecm_add_test(
                Tests.cpp
            TEST_NAME
                fsresizertest
            LINK_LIBRARIES
                ${CALAMARES_LIBRARIES}
                calamares
                calamares_job_fsresizer  # From above
                ${YAMLCPP_LIBRARY}
                Qt5::Core
                Qt5::Test
        )
        set_target_properties( fsresizertest PROPERTIES AUTOMOC TRUE )
        target_include_directories( fsresizertest PRIVATE /usr/local/include )
        target_compile_definitions( fsresizertest PRIVATE ${_partition_defs} )
    endif()
else()
    calamares_skip_module( "fsresizer (missing suitable KPMcore)" )
endif()

=== src/modules/initcpio/CMakeLists.txt ===
calamares_add_plugin( initcpio
    TYPE job
    EXPORT_MACRO PLUGINDLLEXPORT_PRO
    SOURCES
        InitcpioJob.cpp
    LINK_PRIVATE_LIBRARIES
        calamares
    SHARED_LIB
)

if( ECM_FOUND AND BUILD_TESTING )
    ecm_add_test(
            Tests.cpp
        TEST_NAME
            initcpiotest
        LINK_LIBRARIES
            ${CALAMARES_LIBRARIES}
            calamares
            calamares_job_initcpio # From above
            ${YAMLCPP_LIBRARY}
            Qt5::Core
            Qt5::Test
    )
    set_target_properties( initcpiotest PROPERTIES AUTOMOC TRUE )
    target_include_directories( initcpiotest PRIVATE /usr/local/include )
endif()

=== src/modules/initramfs/CMakeLists.txt ===
calamares_add_plugin( initramfs
    TYPE job
    EXPORT_MACRO PLUGINDLLEXPORT_PRO
    SOURCES
        InitramfsJob.cpp
    LINK_PRIVATE_LIBRARIES
        calamares
    SHARED_LIB
)

if( ECM_FOUND AND BUILD_TESTING )
    ecm_add_test(
            Tests.cpp
        TEST_NAME
            initramfstest
        LINK_LIBRARIES
            ${CALAMARES_LIBRARIES}
            calamares
            calamares_job_initramfs # From above
            ${YAMLCPP_LIBRARY}
            Qt5::Core
            Qt5::Test
    )
    set_target_properties( initramfstest PROPERTIES AUTOMOC TRUE )
    target_include_directories( initramfstest PRIVATE /usr/local/include )
endif()

=== src/modules/luksbootkeyfile/CMakeLists.txt ===
calamares_add_plugin( luksbootkeyfile
    TYPE job
    EXPORT_MACRO PLUGINDLLEXPORT_PRO
    SOURCES
        LuksBootKeyFileJob.cpp
    LINK_PRIVATE_LIBRARIES
        calamares
    SHARED_LIB
)

=== src/modules/oemid/CMakeLists.txt ===
calamares_add_plugin( oemid
    TYPE viewmodule
    EXPORT_MACRO PLUGINDLLEXPORT_PRO
    SOURCES
        IDJob.cpp
        OEMViewStep.cpp
    UI
        OEMPage.ui
    LINK_PRIVATE_LIBRARIES
        calamaresui
        Qt5::Widgets
    SHARED_LIB
)

=== src/modules/partition/CMakeLists.txt ===
# When debugging the partitioning widget, or experimenting, you may
# want to allow unsafe partitioning choices (e.g. doing things to the
# current disk). Set DEBUG_PARTITION_UNSAFE to allow that (it turns off
# some filtering of devices).
option( DEBUG_PARTITION_UNSAFE "Allow unsafe partitioning choices." OFF )
option( DEBUG_PARTITION_LAME   "Unsafe partitioning will error out on exec." ON )

set( _partition_defs )
if( DEBUG_PARTITION_UNSAFE )
    if( DEBUG_PARTITION_LAME )
        list( APPEND _partition_defs DEBUG_PARTITION_LAME )
    endif()
    list( APPEND _partition_defs DEBUG_PARTITION_UNSAFE )
endif()

find_package(ECM ${ECM_VERSION} REQUIRED NO_MODULE)

find_package( KPMcore 3.3 )
set_package_properties(
    KPMcore PROPERTIES
    PURPOSE "For partitioning module"
)

if ( KPMcore_FOUND )
    find_package( Qt5 REQUIRED DBus )
    find_package( KF5 REQUIRED Config CoreAddons I18n WidgetsAddons )

    if ( KPMcore_VERSION VERSION_GREATER "3.3.0")
        list( APPEND _partition_defs WITH_KPMCORE331API) # kpmcore > 3.3.0 with deprecations
    endif()
    if ( KPMcore_VERSION VERSION_GREATER "3.90")
        list( APPEND _partition_defs WITH_KPMCORE4API) # kpmcore 4 with new API
    endif()

    include_directories( ${KPMCORE_INCLUDE_DIR} )
    include_directories( ${PROJECT_BINARY_DIR}/src/libcalamaresui )

    add_subdirectory( tests )

    calamares_add_plugin( partition
        TYPE viewmodule
        EXPORT_MACRO PLUGINDLLEXPORT_PRO
        SOURCES
            core/BootLoaderModel.cpp
            core/ColorUtils.cpp
            core/DeviceList.cpp
            core/DeviceModel.cpp
            core/KPMHelpers.cpp
            core/PartitionActions.cpp
            core/PartitionCoreModule.cpp
            core/PartitionInfo.cpp
            core/PartitionIterator.cpp
            core/PartitionLayout.cpp
            core/PartitionModel.cpp
            core/PartUtils.cpp
            gui/BootInfoWidget.cpp
            gui/ChoicePage.cpp
            gui/CreatePartitionDialog.cpp
            gui/CreateVolumeGroupDialog.cpp
            gui/DeviceInfoWidget.cpp
            gui/EditExistingPartitionDialog.cpp
            gui/EncryptWidget.cpp
            gui/ListPhysicalVolumeWidgetItem.cpp
            gui/PartitionPage.cpp
            gui/PartitionBarsView.cpp
            gui/PartitionDialogHelpers.cpp
            gui/PartitionLabelsView.cpp
            gui/PartitionSizeController.cpp
            gui/PartitionSplitterWidget.cpp
            gui/PartitionViewStep.cpp
            gui/PrettyRadioButton.cpp
            gui/ResizeVolumeGroupDialog.cpp
            gui/ScanningDialog.cpp
            gui/ReplaceWidget.cpp
            gui/VolumeGroupBaseDialog.cpp
            jobs/ClearMountsJob.cpp
            jobs/ClearTempMountsJob.cpp
            jobs/CreatePartitionJob.cpp
            jobs/CreatePartitionTableJob.cpp
            jobs/CreateVolumeGroupJob.cpp
            jobs/DeactivateVolumeGroupJob.cpp
            jobs/DeletePartitionJob.cpp
            jobs/FillGlobalStorageJob.cpp
            jobs/FormatPartitionJob.cpp
            jobs/PartitionJob.cpp
            jobs/RemoveVolumeGroupJob.cpp
            jobs/ResizePartitionJob.cpp
            jobs/ResizeVolumeGroupJob.cpp
            jobs/SetPartitionFlagsJob.cpp
        UI
            gui/ChoicePage.ui
            gui/CreatePartitionDialog.ui
            gui/CreatePartitionTableDialog.ui
            gui/EditExistingPartitionDialog.ui
            gui/EncryptWidget.ui
            gui/PartitionPage.ui
            gui/ReplaceWidget.ui
            gui/VolumeGroupBaseDialog.ui
        LINK_PRIVATE_LIBRARIES
            kpmcore
            calamaresui
            KF5::CoreAddons
        COMPILE_DEFINITIONS ${_partition_defs}
        SHARED_LIB
    )
else()
    calamares_skip_module( "partition (missing suitable KPMcore)" )
endif()

=== debian/changelog ===
calamares (3.2.11-0ubuntu1) eoan; urgency=medium

  * New upstream release.
  * Proper handling of files and permissions with FDE: (LP: #1835095)
    - CVE-2019-13178 Set proper umask for luks crypto_keyfile.
    - CVE-2019-13179 Set proper umask for initramfs.
  * Bump Standards-version to 4.4.0, no changes needed.

 -- Dan Simmons <kc2bez@lubuntu.me>  Fri, 12 Jul 2019 19:52:38 -0400

## calamares 3.2.12

=== CMakeLists.txt ===
--- 
+++ 
@@ -35,9 +35,9 @@
 # One special target is "show-version", which can be built
 # to obtain the version number from here.
 
-cmake_minimum_required( VERSION 3.2 FATAL_ERROR )
+cmake_minimum_required( VERSION 3.3 FATAL_ERROR )
 project( CALAMARES
-    VERSION 3.2.11
+    VERSION 3.2.12
     LANGUAGES C CXX )
 
 set( CALAMARES_VERSION_RC 0 )  # Set to 0 during release cycle, 1 during development
@@ -96,21 +96,23 @@
 # (sr@latin in particular) may need special handling in CalamaresUtils.cpp.
 #
 # TODO: drop the es_ES translation from Transifex
-# TODO: move eo (Esperanto) to _ok once Qt can actually create a
-#       locale for it.
-#
-# NOTE: when updating the list from Transifex, copy these four lines
+#
+# NOTE: move eo (Esperanto) to _ok once Qt can actually create a
+#       locale for it. (Qt 5.12.2 can, see check later on).
+# NOTE: update these lines by running txstats.py, or copy these four lines
 #       and prefix each variable name with "p", so that the automatic
 #       checks for new languages and misspelled ones are done (that is,
 #       copy these four lines to four backup lines, add "p", and then update
 #       the original four lines with the current translations).
-set( _tx_complete ca cs_CZ da de fr he hr hu ko lt pt_BR sq tr_TR
-    zh_TW )
-set( _tx_good ast en_GB es es_MX et fi_FI gl id it_IT ja nl pl
-    pt_PT ro ru sk zh_CN )
-set( _tx_ok ar bg el es_PR eu hi is mr nb sl sr sr@latin sv th
-    uk )
-set( _tx_incomplete be ca@valencia eo fa fr_CH gu kk kn lo mk ne_NP ur uz )
+#
+# Total 60 languages
+set( _tx_complete ca cs_CZ da de fi_FI fr he hi hr hu ja ko lt
+    pt_BR sq tr_TR zh_TW )
+set( _tx_good ast en_GB es es_MX et gl id it_IT nl pl pt_PT ru sk
+    zh_CN )
+set( _tx_ok ar bg el es_PR eu is mr nb ro sl sr sr@latin sv th uk )
+set( _tx_incomplete be ca@valencia eo fa fr_CH gu kk kn lo mk ne_NP
+    ur uz )
 
 ### Required versions
 #
@@ -126,6 +128,10 @@
 #
 set( CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/CMakeModules" )
 
+# Enable IN_LIST
+if( POLICY CMP0057 )
+    cmake_policy( SET CMP0057 NEW )
+endif()
 # CMake 3.9, 3.10 compatibility
 if( POLICY CMP0071 )
     cmake_policy( SET CMP0071 NEW )
@@ -192,7 +198,7 @@
     )
         string( APPEND CMAKE_CXX_FLAGS " ${CLANG_WARNINGS}" )
     endforeach()
-    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNOTREACHED='//'" )
+    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNOTREACHED='//' -DFALLTHRU='[[clang::fallthrough]]'")
 
     # Third-party code where we don't care so much about compiler warnings
     # (because it's uncomfortable to patch) get different flags; use
@@ -219,7 +225,7 @@
     set( SUPPRESS_3RDPARTY_WARNINGS "" )
     set( SUPPRESS_BOOST_WARNINGS "" )
 
-    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNOTREACHED='__builtin_unreachable();'" )
+    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNOTREACHED='__builtin_unreachable();' -DFALLTHRU='/* */'" )
 endif()
 
 # Use mark_thirdparty_code() to reduce warnings from the compiler
@@ -247,6 +253,15 @@
 ### DEPENDENCIES
 #
 find_package( Qt5 ${QT_VERSION} CONFIG REQUIRED Concurrent Core Gui Widgets LinguistTools Svg Quick QuickWidgets )
+if( Qt5_VERSION VERSION_GREATER 5.12.1 )
+    # At least Qt 5.12.2 seems to support Esperanto in QLocale
+    if( "eo" IN_LIST _tx_incomplete )
+        message(STATUS "Esperanto support since Qt 5.12.2, enabling Esperanto locale")
+        list( REMOVE_ITEM _tx_incomplete "eo" )
+        list( APPEND _tx_ok "eo" )
+    endif()
+endif()
+
 find_package( YAMLCPP ${YAMLCPP_VERSION} REQUIRED )
 if( INSTALL_POLKIT )
     find_package( PolkitQt5-1 REQUIRED )
@@ -303,20 +318,3 @@
 
     find_package( PythonQt )
     set_package_properties( PythonQt PROPERTIES
-        DESCRIPTION "A Python embedding solution for Qt applications."
-        URL "http://pythonqt.sourceforge.net"
-        PURPOSE "PythonQt is used for Python view modules."
-    )
-endif()
-
-if( NOT PYTHONLIBS_FOUND OR NOT CALAMARES_BOOST_PYTHON3_FOUND )
-    message(STATUS "Disabling Boost::Python modules")
-    set( WITH_PYTHON OFF )
-endif()
-if( NOT PYTHONLIBS_FOUND OR NOT PYTHONQT_FOUND )
-    message(STATUS "Disabling PythonQt modules")
-    set( WITH_PYTHONQT OFF )
-endif()
-
-### Transifex Translation status
-#

=== src/libcalamares/CMakeLists.txt ===
--- 
+++ 
@@ -34,6 +34,7 @@
     locale/Label.cpp
     locale/LabelModel.cpp
     locale/Lookup.cpp
+    locale/TranslatableConfiguration.cpp
 
     # Partition service
     partition/PartitionSize.cpp

=== src/libcalamaresui/CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,7 @@
     utils/CalamaresUtilsGui.cpp
     utils/DebugWindow.cpp
     utils/ImageRegistry.cpp
+    utils/Paste.cpp
 
     utils/qjsonmodel.cpp
     utils/qjsonitem.cpp

=== src/modules/packagechooser/CMakeLists.txt ===
find_package( Qt5 COMPONENTS Core Gui Widgets REQUIRED )
set( _extra_libraries "" )

### OPTIONAL AppData XML support in PackageModel
#
#
find_package(Qt5 COMPONENTS Xml)
if ( Qt5Xml_FOUND )
    add_definitions( -DHAVE_XML )
    list( APPEND _extra_libraries Qt5::Xml )
endif()
    

calamares_add_plugin( packagechooser
    TYPE viewmodule
    EXPORT_MACRO PLUGINDLLEXPORT_PRO
    SOURCES
        PackageChooserPage.cpp
        PackageChooserViewStep.cpp
        PackageModel.cpp
    RESOURCES
        packagechooser.qrc
    UI
        page_package.ui
    LINK_PRIVATE_LIBRARIES
        calamaresui
        ${_extra_libraries}
    SHARED_LIB
)

if( ECM_FOUND AND BUILD_TESTING )
    ecm_add_test(
            Tests.cpp
        TEST_NAME
            packagechoosertest
        LINK_LIBRARIES
            ${CALAMARES_LIBRARIES}
            calamares_viewmodule_packagechooser
            Qt5::Core
            Qt5::Test
            Qt5::Gui
            ${_extra_libraries}
    )
    calamares_automoc( packagechoosertest)
endif()

=== debian/changelog ===
calamares (3.2.12-0ubuntu1) eoan; urgency=medium

  * New upstream release.
  * Update debian/compat to 12, no changes needed.
  * Adjust desktop patch to NotShowIn=LXQt.

 -- Dan Simmons <kc2bez@lubuntu.me>  Sun, 11 Aug 2019 20:46:30 -0400

=== debian/control ===
Source: calamares
Section: utils
Priority: optional
Maintainer: Lubuntu Developers <lubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Jonathan Carter <jcc@debian.org>
Build-Depends: cmake,
               cryptsetup,
               debhelper (>= 12),
               extra-cmake-modules,
               gettext,
               libatasmart-dev,
               libboost-python-dev,
               libkf5config-dev,
               libkf5coreaddons-dev,
               libkf5i18n-dev,
               libkf5iconthemes-dev,
               libkf5kio-dev,
               libkf5parts-dev,
               libkf5service-dev,
               libkf5solid-dev,
               libkpmcore-dev,
               libparted-dev,
               libpolkit-qt5-1-dev,
               libpwquality-dev,
               libpythonqt-qt5-python3-dev,
               libpythonqt-qtall-qt5-python3-dev,
               libqt5svg5-dev,
               libqt5webkit5-dev,
               libyaml-cpp-dev,
               os-prober,
               pkg-config,
               pkg-kde-tools,
               policykit-1,
               python3-dev,
               qml-module-qtquick-layouts,
               qml-module-qtquick-privatewidgets,
               qml-module-qtquick-window2,
               qml-module-qtquick2,
               qtbase5-dev,
               qtdeclarative5-dev,
               qttools5-dev,
               qttools5-dev-tools
Standards-Version: 4.4.0
Homepage: https://github.com/calamares/calamares
Vcs-Browser: https://phab.lubuntu.me/source/calamares/
Vcs-Git: https://phab.lubuntu.me/source/calamares.git
XS-Debian-Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde-extras/calamares
XS-Debian-Vcs-Git: https://salsa.debian.org/qt-kde-team/kde-extras/calamares.git

Package: calamares
Architecture: linux-any
Depends: os-prober, ${misc:Depends}, ${shlibs:Depends}
Recommends: btrfs-progs, squashfs-tools
Description: distribution-independent installer framework
 Calamares is a distribution-independent installer framework.
 .
 It provides a graphical installer that can be used with nearly
 any distribution. This package is suitable for live media on
 Debian-based systems, and won't be of any particular use on
 and already installed system.
 .
 You will likely want to provide your own config files to match
 your distribution, reading the Calamares documentation will guide
 you through that process.

## calamares 3.2.14

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,6 +25,9 @@
 #   SKIP_MODULES    : a space or semicolon-separated list of directory names
 #                     under src/modules that should not be built.
 #   USE_<foo>       : fills in SKIP_MODULES for modules called <foo>-<something>
+#   WITH_<foo>      : try to enable <foo> (these usually default to ON). For
+#                     a list of WITH_<foo> grep CMakeCache.txt after running
+#                     CMake once.
 #   BUILD_<foo>     : choose additional things to build
 #   DEBUG_<foo>     : special developer flags for debugging
 #
@@ -37,7 +40,7 @@
 
 cmake_minimum_required( VERSION 3.3 FATAL_ERROR )
 project( CALAMARES
-    VERSION 3.2.12
+    VERSION 3.2.14
     LANGUAGES C CXX )
 
 set( CALAMARES_VERSION_RC 0 )  # Set to 0 during release cycle, 1 during development
@@ -105,14 +108,14 @@
 #       copy these four lines to four backup lines, add "p", and then update
 #       the original four lines with the current translations).
 #
-# Total 60 languages
-set( _tx_complete ca cs_CZ da de fi_FI fr he hi hr hu ja ko lt
-    pt_BR sq tr_TR zh_TW )
-set( _tx_good ast en_GB es es_MX et gl id it_IT nl pl pt_PT ru sk
-    zh_CN )
-set( _tx_ok ar bg el es_PR eu is mr nb ro sl sr sr@latin sv th uk )
-set( _tx_incomplete be ca@valencia eo fa fr_CH gu kk kn lo mk ne_NP
-    ur uz )
+# Total 61 languages
+set( _tx_complete ca cs_CZ da fi_FI he hr ja lt pt_BR sq )
+set( _tx_good ast de es es_MX et fr gl hi hu id it_IT ko nl pl
+    pt_PT ru sk tr_TR zh_TW )
+set( _tx_ok ar be bg el en_GB es_PR eu is ml mr nb ro sl sr
+    sr@latin sv th uk zh_CN )
+set( _tx_incomplete ca@valencia eo fa fr_CH gu kk kn lo mk ne_NP ur
+    uz )
 
 ### Required versions
 #
@@ -195,6 +198,7 @@
         -Wno-missing-prototypes
         -Wno-documentation-unknown-command
         -Wno-unknown-warning-option
+        -Werror=return-type
     )
         string( APPEND CMAKE_CXX_FLAGS " ${CLANG_WARNINGS}" )
     endforeach()
@@ -261,6 +265,8 @@
         list( APPEND _tx_ok "eo" )
     endif()
 endif()
+# Optional Qt parts
+find_package( Qt5DBus CONFIG )
 
 find_package( YAMLCPP ${YAMLCPP_VERSION} REQUIRED )
 if( INSTALL_POLKIT )
@@ -291,7 +297,14 @@
     include(KDEInstallDirs)
 endif()
 
-find_package( KF5 COMPONENTS CoreAddons Crash )
+find_package( KF5 QUIET COMPONENTS CoreAddons Crash )
+set_package_properties(
+    KF5::CoreAddons PROPERTIES
+    TYPE REQUIRED
+    DESCRIPTION "Classes built on QtCore for About Data"
+    URL "https://api.kde.org/frameworks/kcoreaddons/"
+    PURPOSE "About Calamares"
+)
 if( NOT KF5Crash_FOUND )
     set( WITH_KF5Crash OFF )
 endif()
@@ -303,18 +316,3 @@
 find_package( PythonLibs ${PYTHONLIBS_VERSION} )
 set_package_properties(
     PythonLibs PROPERTIES
-    DESCRIPTION "C interface libraries for the Python 3 interpreter."
-    URL "http://python.org"
-    PURPOSE "Python 3 is used for Python job modules."
-)
-
-if ( PYTHONLIBS_FOUND )
-    include( BoostPython3 )
-    find_boost_python3( ${BOOSTPYTHON_VERSION} ${PYTHONLIBS_VERSION_STRING} CALAMARES_BOOST_PYTHON3_FOUND )
-    set_package_properties(
-        Boost PROPERTIES
-        PURPOSE "Boost.Python is used for Python job modules."
-    )
-
-    find_package( PythonQt )
-    set_package_properties( PythonQt PROPERTIES

=== src/calamares/CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,9 @@
     main.cpp
     CalamaresApplication.cpp
     CalamaresWindow.cpp
+
+    DebugWindow.cpp
+    VariantModel.cpp
 
     progresstree/ProgressTreeDelegate.cpp
     progresstree/ProgressTreeItem.cpp
@@ -17,8 +20,9 @@
     ${CMAKE_CURRENT_BINARY_DIR}
     ${CMAKE_CURRENT_BINARY_DIR}/../libcalamares
 
-    ../libcalamares
-    ../libcalamaresui
+    ${CMAKE_SOURCE_DIR}/src/libcalamares
+    ${CMAKE_SOURCE_DIR}/src//libcalamaresui
+    ${CMAKE_SOURCE_DIR}
 )
 
 # Translations
@@ -34,6 +38,7 @@
         RUNTIME_OUTPUT_NAME calamares
 )
 calamares_automoc( calamares_bin )
+calamares_autouic( calamares_bin )
 
 target_link_libraries( calamares_bin
     PRIVATE
@@ -41,11 +46,11 @@
         calamaresui
         Qt5::Core
         Qt5::Widgets
+        KF5::CoreAddons
 )
 if( WITH_KF5Crash )
     target_link_libraries( calamares_bin
         PRIVATE
-            KF5::CoreAddons
             KF5::Crash
     )
     target_compile_definitions( calamares_bin PRIVATE WITH_KF5Crash )

=== src/libcalamares/CMakeLists.txt ===
--- 
+++ 
@@ -35,6 +35,9 @@
     locale/LabelModel.cpp
     locale/Lookup.cpp
     locale/TranslatableConfiguration.cpp
+
+    # Network service
+    network/Manager.cpp
 
     # Partition service
     partition/PartitionSize.cpp
@@ -51,12 +54,16 @@
     utils/Variant.cpp
     utils/Yaml.cpp
 )
-set( kdsagSources
+set( _kdsagSources
     kdsingleapplicationguard/kdsingleapplicationguard.cpp
     kdsingleapplicationguard/kdsharedmemorylocker.cpp
     kdsingleapplicationguard/kdtoolsglobal.cpp
     kdsingleapplicationguard/kdlockedsharedmemorypointer.cpp
 )
+set( kdsagSources "" )
+foreach( _s ${_kdsagSources} )
+    list( APPEND kdsagSources ${CMAKE_SOURCE_DIR}/3rdparty/${_s} )
+endforeach()
 mark_thirdparty_code( ${kdsagSources} )
 
 include_directories(
@@ -116,6 +123,7 @@
     LINK_PUBLIC
         ${YAMLCPP_LIBRARY}
         Qt5::Core
+        KF5::CoreAddons
         ${OPTIONAL_PUBLIC_LIBRARIES}
 )
 
@@ -189,6 +197,26 @@
             Qt5::Test
     )
     calamares_automoc( libcalamareslocaletest )
+
+    ecm_add_test(
+            network/Tests.cpp
+        TEST_NAME
+            libcalamaresnetworktest
+        LINK_LIBRARIES
+            calamares
+            Qt5::Test
+    )
+    calamares_automoc( libcalamaresnetworktest )
+
+    ecm_add_test(
+            modulesystem/Tests.cpp
+        TEST_NAME
+            libcalamaresmodulesystemtest
+        LINK_LIBRARIES
+            calamares
+            Qt5::Test
+    )
+    calamares_automoc( libcalamaresmodulesystemtest )
 endif()
 
 if( BUILD_TESTING )

=== src/modules/fsresizer/CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,11 @@
 find_package( KPMcore 3.3 )
+find_package( KF5Config CONFIG )
+find_package( KF5I18n CONFIG )
+find_package( KF5WidgetsAddons CONFIG )
 
 set( _partition_defs "" )
 
-if ( KPMcore_FOUND )
-    find_package( Qt5 REQUIRED DBus )  # Needed for KPMCore
-    find_package( KF5 REQUIRED I18n WidgetsAddons )  # Needed for KPMCore
-
+if ( KPMcore_FOUND AND Qt5DBus_FOUND AND KF5CoreAddons_FOUND AND KF5Config_FOUND )
     include_directories( ${KPMCORE_INCLUDE_DIR} ${CMAKE_SOURCE_DIR}/src/modules/partition )
 
     if ( KPMcore_VERSION VERSION_GREATER "3.3.0")
@@ -48,5 +48,9 @@
         target_compile_definitions( fsresizertest PRIVATE ${_partition_defs} )
     endif()
 else()
-    calamares_skip_module( "fsresizer (missing suitable KPMcore)" )
+    if ( NOT KPMcore_FOUND )
+        calamares_skip_module( "fsresizer (missing suitable KPMcore)" )
+    else()
+        calamares_skip_module( "fsresizer (missing dependencies for KPMcore)" )
+    endif()
 endif()

=== src/modules/initramfs/CMakeLists.txt ===
--- 
+++ 
@@ -21,6 +21,5 @@
             Qt5::Core
             Qt5::Test
     )
-    set_target_properties( initramfstest PROPERTIES AUTOMOC TRUE )
-    target_include_directories( initramfstest PRIVATE /usr/local/include )
+    calamares_automoc( initramfstest )
 endif()

=== debian/changelog ===
calamares (3.2.14-0ubuntu2) eoan; urgency=medium

  * Refresh apport-package-hook.patch for change in log directory
    name.

 -- Dan Simmons <kc2bez@lubuntu.me>  Wed, 09 Oct 2019 18:04:16 -0400

calamares (3.2.14-0ubuntu1) eoan; urgency=medium

  * New upstream release.
  * Update copyright information for appdata file.
  * Do not build against PythonQt.
  * Update copyright to point to 3rdparty code directory.

 -- Dan Simmons <kc2bez@lubuntu.me>  Tue, 08 Oct 2019 18:55:30 -0400

=== debian/control ===
--- 
+++ 
@@ -22,8 +22,6 @@
                libparted-dev,
                libpolkit-qt5-1-dev,
                libpwquality-dev,
-               libpythonqt-qt5-python3-dev,
-               libpythonqt-qtall-qt5-python3-dev,
                libqt5svg5-dev,
                libqt5webkit5-dev,
                libyaml-cpp-dev,
